**Projekt Alumnihub**

**Lastenheft**

**Inhaltsverzeichnis**

- [Zweck des Dokumentes und Scope](#zweck-des-dokumentes-und-scope)
  - [Zweck des Dokumentes](#zweck-des-dokumentes)
  - [Scope und Abgrenzung](#scope-und-abgrenzung)
- [Grundlagen](#grundlagen)
  - [Verwendete Normen und mitgeltende Dokumente](#verwendete-normen-und-mitgeltende-dokumente)
- [Hardwareanforderungen](#hardwareanforderungen)
  - [Allgemeine Anforderunge](#allgemeine-anforderunge)
  - [Anforderungen an Server](#anforderungen-an-server)
  - [Anforderungen an den Bedienrechner / das mobile Endgerät](#anforderungen-an-den-bedienrechner--das-mobile-endgerät)
  - [Anforderungen an das Backup, Recovery und Desaster-Recovery](#anforderungen-an-das-backup-recovery-und-desaster-recovery)
  - [Anforderungen an Redundanz und Verfügbarkeit](#anforderungen-an-redundanz-und-verfügbarkeit)
    - [Redundanzeigenschaften](#redundanzeigenschaften)
    - [Verfügbarkeitsanforderungen](#verfügbarkeitsanforderungen)
  - [Schnittstellen](#schnittstellen)
    - [Schnittstellen zu eigenen Systemen](#schnittstellen-zu-eigenen-systemen)
    - [Schnittstellen zu anderen Systemen](#schnittstellen-zu-anderen-systemen)
- [Anforderungen an die Software](#anforderungen-an-die-software)
  - [Allgemeine Anforderungen](#allgemeine-anforderungen)
  - [Zugriffsverwaltung](#zugriffsverwaltung)
  - [Hall of Fame (Phase 2)](#hall-of-fame-phase-2)
  - [Firmen und Jobstellenmarkt (Phase 2)](#firmen-und-jobstellenmarkt-phase-2)
  - [Premiumbereich (Phase 2)](#premiumbereich-phase-2)
  - [Auswertungen](#auswertungen)
  - [Datenschutz \& Informationssicherheit](#datenschutz--informationssicherheit)
  - [Schwarzes Brett (Phase 2)](#schwarzes-brett-phase-2)
  - [Anmeldetool für Treffen](#anmeldetool-für-treffen)
  - [Profilverwaltung](#profilverwaltung)
- [Datenbank](#datenbank)
- [Dokumentation](#dokumentation)
  - [Projektdokumentation](#projektdokumentation)


# Zweck des Dokumentes und Scope

## Zweck des Dokumentes

*Der Zweck dieses Dokuments ist die Beschreibung der Anforderungen an die Hardware und an die Web-Anwendung für den Absolventenverband.*

*Das Ziel dieses Lastenhefts ist die detaillierte Beschreibung der Anforderungen an die zu entwickelnde Applikation für den Absolventenverband. Diese Applikation soll es ermöglichen, Absolventen zu verwalten, Veranstaltungen zu organisieren, eine Jobbörse zu integrieren und die Kommunikation innerhalb des Verbands zu verbessern. Dabei sollen verschiedene Rollen- und Berechtigungskonzepte berücksichtigt werden, und die Applikation soll in mehreren Phasen umgesetzt werden, wobei Funktionalitäten priorisiert werden.*

*Die Applikation soll eine zentrale Plattform für Absolventen sein, über die sie sich registrieren, austauschen und auf relevante Angebote zugreifen können. Kernkomponenten wie das Anmeldetool für Treffen, die Hall of Fame und der Jobstellenmarkt werden ergänzt durch optionale Funktionen wie die Integration von LinkedIn für Profilabgleiche und einen Premiumbereich für zahlende Nutzer.*

## Scope und Abgrenzung

*Abgrenzung / Was kommt in Phase 1 hinein?*

*Das Projekt umfasst die Entwicklung der Applikation mit den Funktionen für die Verwaltung von Absolventenprofilen, die Organisation von Veranstaltungen, die Darstellung der Hall of Fame, sowie die Integration eines Firmen- und Jobstellenmarkts. Die Zugriffsverwaltung sowie die Sicherheit der Daten (DSGVO-konform) sind wesentliche Bestandteile. Optional sind Erweiterungen wie ein Schülerzugang oder die Integration eines CMS für redaktionelle Beiträge. Nicht in den Scope fallen jedoch Zahlungsprozesse für den Premiumbereich und externe Lösungen für den Eventkalender (V-Calendar, V-Event), die separat betrachtet werden.*

# Grundlagen

## Verwendete Normen und mitgeltende Dokumente

*Die bestehenden Gesetze und technischen Regelwerke sind zu beachten. Insbesondere sind im Kontext des gegenständlichen Dokumentes die folgenden Normen zu berücksichtigen:*

*Die Applikation muss unter Beachtung der folgenden Normen und rechtlichen Vorgaben entwickelt werden:*

*- DSGVO (Datenschutz-Grundverordnung): Es dürfen nur notwendige personenbezogene Daten gespeichert werden, wie E-Mail, Telefonnummer und Land/Bundesland​. Ein Opt-In-Verfahren wird für die Speicherung von Nutzerdaten angewendet, und es muss die Möglichkeit zur Löschung von Einträgen geben (Rückwirkend möglich)*
*- NIS 2 Richtlinie (Netz- und Informationssicherheit); Als digitaler Dienstanbieter müssen Sicherheitsanforderungen eingehalten werden. Besonders die sichere Aufbewahrung und Verwaltung von Nutzerdaten, sowie der Schutz vor Datenverlust sind hier entscheidend​.*

*Weitere Bestimmungen, wie die Handhabung der Benutzerrechte und Datenschutzrichtlinien im Zusammenhang mit Drittanbieter-APIs (z. B. LinkedIn-OAuth), müssen ebenfalls geprüft und eingehalten werden.*

# Hardwareanforderungen

## Allgemeine Anforderunge

*Phase 2: Schülerzugang braucht mehr Nutzer…. Zugriffe / Tag steigen auch.*
Um den nachfolgenden Anforderungen gerecht zu werden, nutzen wir:
| Produkt | Preis |
| --- | --- |
| 2* Hetzner CX22 | 3.79€ / Montat / Server |
| Domain (easyname.at) | 35€ / Jahr |
| Mailservice (Brevo) | 0€ / Jahr |

|Anforderung|ID|
| --- | --- |
| **300 aktuellen Nutzern**  <br>Das System muss mindestens 300 aktuelle Benutzer unterstützen, die das System administrieren, bearbeiten und nutzen können. Nicht jeder Benutzer benötigt ein eigenes Profil. | HW-1 |
| **ca. 50 Zugriffe / Tag**  <br>Das System muss in der Lage sein, ca. 50 aktive Benutzer pro Tag (tendenziell steigend) zu unterstützen, ohne dass die Systemleistung beeinträchtigt wird. Die Systemressourcen sollten ausreichend dimensioniert sein, um eine reibungslose und effiziente Nutzung durch die Benutzer zu gewährleisten. | HW-2 |
| **Einfach skalierbar**  <br>Das System muss einfach skaliert werden können, um aufsteigende Anforderungen und Benutzerzahlen reagieren zu können. Dies sollte ohne wesentliche Änderungen an der Systemarchitektur oder -Infrastruktur möglich sein, um eine flexible und kosteneffiziente Anpassung an zukünftige Bedürfnisse zu ermöglichen. | HW-3 |

## Anforderungen an Server

Phase 2: Schülerzugang braucht mehr Nutzer…. Zugriffe / Tag steigen auch.

|Anforderung|ID|
| --- | --- |
| **Die Anwendung wird auf einem Cloud-Server betrieben, der skalierbar ist, um den Anforderungen eines wachsenden Benutzerstamms gerecht zu werden.** | HW-4 |
| **Hochverfügbar: 99.5%** <br>Damit diese Anforderung auch im Falle eines gröberen Ausfalls eingehalten werden kann, muss es diverse Dokumentation und Anleitungen zum Wiederherstellungsprozesses geben. Es wird ein eigenes Desaster Recovery Handbuch geben. Damit diverse Probleme schnell erkannt werden, wird es ein rudimentäres Logging geben. (Wie viele Requests? Ressourcenverbrauch? Durchschnittliche antwortzeit des Servers...) Sollte einer dieser Werte auffällig weit aus der Norm fallen, wird der Absolventenverein, sowie diese Diplomarbeitsgruppe automatisch benachrichtigt, damit mit untersuchungen / gegenmaßnahmen in angriff genommen.<br> *Das System muss eine Verfügbarkeit von mindestens 99,5% aufweisen. Dies bedeutet, dass das System innerhalb eines Jahres höchstens 43,8 Stunden (0,5% von 8760 Stunden) nicht verfügbar sein darf.* | HW-5 |
| **.Net Runtime muss unterstützt werden** <br> Die Anwendung muss die .NET Runtime unterstützen, um eine reibungslose Ausführung von .NET-basierten Anwendungen zu ermöglichen. | HW-6 |
| **Wiederherstellungszeitraum**<br><br> Die Wiederherstellung des Servers im Falle eines Ausfalls (des Rechenzentrums) muss innerhalb von **einem Tag** gewährleistet sein. Also nach 24 Stunden muss das System wieder in einen benutzbaren Zustand gebracht werden | HW-7 |

## Anforderungen an den Bedienrechner / das mobile Endgerät

| **Moderner Browser (Chrome, Firefox, Safari und Edge)** | HW-9 |
| --- | --- |
| **JavaScript muss aktiv sein.** | HW-10 |
| **Internetverbindung (5 MBit/s)** | HW-11 |

## Anforderungen an das Backup, Recovery und Desaster-Recovery

| Anforderung | ID |
| --- | --- |
| **Automatisierte Datensicherung**<br>Zur Erhöhung der Datensicherheit soll über das Komplettsystem eine automatisierte Datensicherung erfolgen. Versionen / Binaries der Anwendungen, Konfigurationsdateien und Nutzerdaten, die Datenbank... Diese Dateien werdenauf einem unbhängigen File Server gelagert. Die Binaries sollen nur bei Updates unserer Software ausgetauscht werden, Konfigurationen bei Änderung erneuert gesichert und die Datenbank mit Nutzerdaten in einem regelmäßigen Zeitfenster. (Vielleicht misbrauchen wir einfach ein Git Repository, das ist vorallem für die Versionierung und Automatisierung dieser Backups sehr gut geeignet) | HW-12 |
| **Dokumentation zum Wiederherstellungsverfahren muss vorhanden sein.**<br><br>Schritt für Schritt Anweisungen zum Wiederherstellen des Systems. Skriptgestützte Automatische Wiederherstellung mit einer Dokumentation/Tutorial, um dieses Disaster-Recovery auch ohne Skript durchführen zu können. | HW-13 |

## Anforderungen an Redundanz und Verfügbarkeit

### Redundanzeigenschaften

Redundanzeigenschaften Bespr. Mit Hr. Prof. Gürth

| Anforderung | ID |
| --- | --- |
| **Datenbank und Anwendung muss redundant und gegen Ausfall eines Servers gesichert sein.** <br> Die Datenbank wird auf beiden Servern repliziert vorhanden sein. Ob das ein warm-standby, hot-standby, oder gar eine Multi-Master Replizierung wird, muss noch entschieden werden. Im Falle eines Ausfalls einer der beiden DBs, soll die andere automatisch zum neuen Master "promoted" werden, wodurch die Anwendung ohne einen groß Merkbaren ausfall direkt weiter ausgeführt werden kann. <br> Außerdem soll regelmäßig ein Backup von der gesamten Datenbank gemacht werden, welches auf einem unabhängigen File Server/Provider gelagert wird, um im Falle eines Datenverlustes die DB wiederher zu stellen. *<br> Die Datenbank und die Anwendung müssen redundant und gegen Ausfälle gesichert sein, um Datenverluste und Systemausfälle zu vermeiden. Dies umfasst die Implementierung von:</p><ul><li>Datenbankreplikation</li><li>Regelmäßige Backups und Datenwiederherstellung</li></ul>* | RED-1 |

### Verfügbarkeitsanforderungen

| **99% / Jahr (87.6h)**<br>Durch eine schnelle Wiederherstellungszeit und klar vorgegebene Disaster Recovery Dokumentation und resilienz in der Architektur des Systems, sowie ein Monitoring und Logging zur frühen Erkennung etwaiger Probleme werden die 99% / Jahr eingehalten werden.<br>Das System soll weniger als 90 Stunden im Jahr ausfallen. | RED-4 |
| --- | --- |
| **Wiederherstellungszeit: the next business day**<br>Durch weitgehende automatisierte Skripte soll der Wiederherstellungsprozess vereinfacht werden. Ein Desaster-Recovery Handbuch liegt bei, um den Benutzer schritt für Schritt durch den Wiederherstellungsprozess zu begleiten.<br>Das System soll bis zum übernächsten Werktag wieder in einen Nutzbaren zustand bringbar sein. | RED-5 |
|     |     |

## Schnittstellen

### Schnittstellen zu eigenen Systemen

| Anforderung | ID |
| --- | --- |
| RestAPI (Frontend / Backend)<br><br>1. Zielsetzung <br>Die geplante REST API soll in die Oqtane-CMS-Umgebung integriert werden, um eine dynamische Kommunikation zwischen dem CMS und einer Website zu ermöglichen. Sie dient dazu, Inhalte und Funktionen des CMS über die API für die Website verfügbar zu machen und ermöglicht dynamische CRUD-Operationen (Create, Read, Update, Delete) direkt aus dem CMS heraus.<br><br>2. Aufgabenbeschreibung<br>Die Aufgabe umfasst:<br>Integration in Oqtane: Erweiterung des Oqtane-CMS mit zusätzlichen Modulen und APIs.<br>Entwicklung der REST API: Bereitstellung von Endpunkten zur Interaktion zwischen CMS-Daten und Website.<br>Frontend-Integration: Anbindung der Website an die API, um CMS-Inhalte dynamisch darzustellen.<br>Sicherheitsimplementierung: Absicherung der API und des Datenflusses zwischen CMS und Website.<br><br>3. Sicherheitsanforderungen<br>Authentifizierung:<br>Verwendung von Oqtane's integriertem Benutzermanagement und JWT für Authentifizierung.<br>Sicherstellung, dass Benutzerrollen (z. B. Admin, Editor, User) berücksichtigt werden.<br>Autorisierung:<br>Zugriff auf Endpunkte wird basierend auf Benutzerrollen gesteuert.<br>Sensible Aktionen (z. B. Inhalte löschen) nur für berechtigte Benutzer möglich.<br>Eingabedatenvalidierung:<br>Eingaben im Frontend und Backend validieren.<br>API-Schutz:<br>Schutz gegen CSRF, XSS, und andere Angriffe.<br>Nutzung von HTTPS.<br><br>4. Nicht-funktionale Anforderungen<br>Performance: Antwortzeiten der API < 300ms für häufige Anfragen.<br>Kompatibilität: Vollständig kompatibel mit Oqtane-Modulen und Standard-Datenstrukturen.<br>Skalierbarkeit: Möglichkeit, neue Module und API-Endpunkte ohne größere Umbauten zu integrieren.<br>Internationalisierung: Unterstützung mehrsprachiger Inhalte.<br><br>5. Technische Umsetzung<br>5.1. Backend (Oqtane CMS)<br>Framework: ASP.NET Core, integriert in Oqtane.<br>Architektur:<br>Erweiterung des Oqtane-CMS durch Module.<br>Nutzung der Oqtane-Service-API und Datenzugriff über die vorhandene Architektur.<br>Erstellung benutzerdefinierter APIs mit .Controllers und Abbildung auf Oqtane-Tabellen.<br>5.2. Frontend<br>Technologien:<br>JavaScript-Frameworks wie React, Angular oder Vue.js.<br>Integration der REST API über Bibliotheken wie Axios oder die Fetch API.<br>Darstellung der Inhalte aus Oqtane in dynamischen Komponenten (z. B. Listen, Detailansichten).<br>API-Integration:<br>Frontend ruft Inhalte direkt von der REST API ab.<br>Dynamische Aktualisierung der Inhalte durch Benutzeraktionen (z. B. Formularübermittlung).<br>5.3. Sicherheit<br>Authentifizierung:<br>Authentifizierung über JWT-Token (Login-Endpunkte in Oqtane).<br>Speicherung von Token im sicheren Speicher (z. B. HttpOnly Cookies).<br>Eingabeverarbeitung:<br>Validierung von Daten im Frontend und Backend.<br>Schutz vor schädlichen Nutzereingaben (z. B. SQL-Injection).<br><br>6. Erfolgskriterien<br>Die Website kann nahtlos mit der Oqtane-REST API interagieren.<br>Die API erfüllt alle funktionalen Anforderungen und ist in die Oqtane-Datenstruktur integriert.<br>Sichere und performante Bereitstellung der API.<br>Modularer Aufbau, der zukünftige Erweiterungen unterstützt.<br><br> | SnT-1 |

### Schnittstellen zu anderen Systemen

| Anforderung | ID |
| --- | --- |
| SMTP (Email versand)<br><br>1. Zielsetzung<br>Die Implementierung eines SMTP-basierten E-Mail-Versands in der C#-Backend-Anwendung ermöglicht das Versenden von E-Mails über einen konfigurierten<br> Mailserver. Dies umfasst sowohl systemgenerierte E-Mails (z. B. Bestätigungen, Benachrichtigungen) als auch benutzergenerierte Inhalte.<br>Das Ziel ist eine zuverlässige, sichere und skalierbare Lösung für den E-Mail-Versand.<br><br>2. Aufgabenbeschreibung<br>Die Aufgabe umfasst:<br>Konfiguration des SMTP-Servers: Festlegung von Parametern wie Host, Port, Authentifizierung und Verschlüsselung.<br>Erstellung von E-Mail-Nachrichten: Gestaltung der E-Mails im Text- und HTML-Format.<br>Integration in die C#-Backend-Anwendung: Nutzung von SMTP-Befehlen über .NET-Bibliotheken.<br>Fehlerbehandlung und Logging: Sicherstellung eines robusten Versandprozesses und Nachverfolgung fehlerhafter E-Mails.<br>Sicherheitsmaßnahmen: Schutz der E-Mail-Kommunikation und Verhinderung von Missbrauch.<br><br>3. Dynamischer Versand<br>Benachrichtigungs-E-Mails:<br>Beispiele: Willkommens-E-Mails, Passwort-Zurücksetzen, Bestellbestätigungen.<br>Dynamische Platzhalter (z. B. {Name}, {Bestellnummer}) für personalisierte Inhalte.<br>Massen-E-Mails:<br>Versand an mehrere Empfänger (z. B. Newsletter).<br>Nutzung von BCC oder sequentiellem Versand.<br>3.1 Fehler- und Zustellungsmanagement<br>Protokollierung von fehlgeschlagenen E-Mails (z. B. ungültige Adresse, Verbindung zum SMTP-Server fehlgeschlagen).<br>Rückmeldung an die Anwendung, wenn der Versand erfolgreich war.<br>Möglichkeit zur späteren Wiederholung fehlgeschlagener E-Mails.<br><br>4. Nicht-funktionale Anforderungen<br>Performance:<br>E-Mails sollen innerhalb von 3 Sekunden pro Nachricht versendet werden.<br>Unterstützung von mindestens 100 gleichzeitigen E-Mails bei Massenversand.<br>Skalierbarkeit:<br>Vorbereitung auf den Versand von bis zu 10.000 E-Mails pro Tag.<br>Sicherheit:<br>Verschlüsselung der Verbindung zum SMTP-Server (TLS/SSL).<br>Schutz vor Spam und Missbrauch (z. B. Rate-Limiting).<br>Kompatibilität:<br>Unterstützung moderner E-Mail-Clients (z. B. Gmail, Outlook, Thunderbird).<br>Sicherstellung der Anzeige von HTML-E-Mails auf Desktop- und Mobilgeräten.<br><br>5. Technische Umsetzung<br>5.1. Backend<br>Framework: ASP.NET Core.<br>Bibliotheken:<br>Verwendung von .NET System.Net.Mail oder externen Bibliotheken wie MailKit oder FluentEmail für erweiterten SMTP-Support.<br>Architektur:Erstellung eines SMTP-Services:Methoden für das Versenden von einfachen und komplexen E-Mails.Unterstützung für Anhänge und Templates.<br><br>5.2. Sicherheit<br>Schutz der Zugangsdaten:<br>Verwendung eines Secret Managers oder von Umgebungsvariablen für SMTP-Zugangsdaten.<br>Rate Limiting:<br>Begrenzung der Anzahl der E-Mails pro Zeitspanne, um Serverüberlastung zu vermeiden.<br>Spam-Prävention:<br>Konfiguration von SPF, DKIM und DMARC auf der Mailserver-Seite.<br><br>6. Erfolgskriterien<br>Alle E-Mails werden zuverlässig und sicher über den SMTP-Server versendet.<br>Personalisierte Nachrichten und Anhänge werden korrekt verarbeitet.<br>Robustheit gegen typische Fehler und Schutz vor Missbrauch.<br><br>| SnT-2 |
| LinkedÌn OAuth (Phase 2, oder später)<br><br>Backend zu LinkedIn<br><br>1. Zielsetzung<br>Implementierung von LinkedIn OAuth 2.0 für die Authentifizierung und den Abruf von Profildaten in der C#-Backend-Anwendung.<br><br>2. Anforderungen<br>Registrierung der App im LinkedIn Developer Portal.<br>OAuth 2.0 Authentifizierungsablauf:<br>Weiterleitung zur LinkedIn-Login-Seite.<br>Empfang des Autorisierungscodes.<br>Austausch des Codes gegen ein Zugriffstoken.<br>Abruf von Benutzerinformationen (Vorname, Nachname, E-Mail).<br>Sicheres Token-Management (kein Speichern von Zugangsdaten in der Datenbank).<br><br>3. Technische Umsetzung<br>Backend: ASP.NET Core<br>API-Endpunkte:<br>/auth/linkedin (Weiterleitung zur LinkedIn-Login-Seite).<br>/auth/linkedin/callback (Empfang des Codes).<br>/api/user/profile (Abruf von LinkedIn-Daten mit Token).<br>Sicherheit:<br>Nutzung von HTTPS und PKCE.<br>Speicherung von Tokens nur im Cache (z. B. Redis).<br>Einschränkung der API-Berechtigungen (r_liteprofile, r_emailaddress).<br><br>4. Erfolgskriterien<br>Benutzer können sich sicher über LinkedIn anmelden.<br>Zugriffstoken werden sicher verarbeitet.<br>API-Datenabruf funktioniert zuverlässig.<br> | SnT -3 |

# Anforderungen an die Software

## Allgemeine Anforderungen

| Anforderung | ID |
| --- | --- |
| Die Website oder Webanwendung wird so entwickelt, dass sie in den aktuellen und vorherigen Versionen der gängigsten Webbrowser einwandfrei funktioniert: </p><p> Google Chrome (Desktop und Mobile) <br>Mozilla Firefox (Desktop und Mobile)<br>Safari (macOS und iOS)<br>Microsoft Edge (Chromium-basiert)</p><p> 1. Programmiersprachen und Standards: <br> -Die Entwicklung erfolgt auf Basis moderner Technologien wie HTML5, CSS3 für eine plattformübergreifende Funktionalität.</p><p> 2. Frameworks und Bibliotheken: <br> -Frameworks wie React, Angular oder Vue.js (für die Frontend-Entwicklung) sowie CSS-Frameworks wie Bootstrap oder TailwindCSS können zum Einsatz kommen.</p><p> 3. Build-Tools: <br> -Tools wie Webpack, Vite oder Parcel werden zur Optimierung der Assets (z. B. Minifizierung und Bundling von Dateien) verwendet,um die Performance auf verschiedenen Browsern zu gewährleisten. <br><br> | SW-1 |
| Barrierefreiheit (WAI-ARIA-Standard) ...</p><p> <b> 1. Verwendung von ARIA-Attributen: </b> <br> -Semantik und Bedienbarkeit durch role, aria-label, aria-expanded, aria-live etc. verbessern.<br>-Dynamische Inhalte und interaktive Elemente mit Attributen wie aria-controls oder aria-describedby ausstatten. </p><p> <b> 2. Technologien und Tools:</b> <br>-Unterstützung durch Frameworks (z. B. React, Angular) und CSS-Frameworks (z. B. Bootstrap). <br>-Einsatz von Tools wie Axe, Lighthouse oder eslint-plugin-jsx-a11y zur Validierung. </p><p> <b> 3. Tastaturbedienbarkeit und Kontraste:</b> <br>-Sicherstellen, dass alle Inhalte per Tastatur erreichbar sind.<br> -Einhalten der Kontrastvorgaben gemäß WCAG 2.1 Stufe AA. <br><br> | SW-2 |
| **CMS**: <br>Das System soll einen redaktionellen Schülerzugagng bieten, damit die Diplomarbeiten von Schülern selbst eingepflegt werden können. | SW-3 |
| **Sicherheit und administrativer Zugriff:** <br> Der Administrative zugriff auf das System geschieht über eine SSH Verbindung, welche nur duch eine VPN (Wireguard) aufgebaut werden kann. Die Authentifizierung (der VPN und SSH) wird über Schlüsselpaare gemacht, um sicherer gegenüber bruteforce Angriffe zu sein. <br> Der Zugriff auf die Anwendung und die Infrastruktur muss jederzeit gegeben sein. Dies kann durch die Implementierung von:</p><ul><li>SSH-Zugriff für Administratoren</li><li>VPN-Verbindung (Virtual Private Network) für eine sichere und verschlüsselte Verbindung</li><li>Zugriffskontrolle und Authentifizierung, um den Zugriff auf autorisierte Personen zu beschränken</li></ul> erreicht werden. | SW-4 |

## Zugriffsverwaltung

| Anforderung | ID |
| --- | --- |
| **Benutzername und Passwort Authentifizierung**: <br> **Im Frontend**: <br> Die Benutzername- und Passwort-Authentifizierung ermöglicht es Nutzern, sich in einer Anwendung zu identifizieren, indem sie ihre Anmeldedaten über ein Formular eingeben. Das Frontend sendet die Daten sicher an das Backend, das die Authentifizierung übernimmt. Bei erfolgreicher Anmeldung erhält der Nutzer Zugriff auf geschützte Bereiche der Anwendung. <br> **Vorraussetzungen**: <br><ol><li>Backend-Anforderungen <ul><li>Mechanismen zur Passwort-Validierung und Token-Generierung (z. B. JWT).</li><li>HTTPS für sichere Datenübertragung.</li></ul></li><li>Frontend-Anforderungen <ul><li>Möglichkeit zur Verarbeitung und sicheren Übertragung der Eingaben.</li><li>Mechanismus zur Speicherung von Authentifizierungsdaten (z. B. Tokens).</li></ul></li></ol> **Diese gelten für alle folgenden Punkte!** <br> **Benötigte Komponenten**: <ol><li>Login-Formular: <ul><li>Eingabefelder für Benutzername und Passwort.</li><li>Submit-Button.</li><li>Fehleranzeige bei ungültigen Eingaben oder falschen Daten.</li></ul></li><li>HTTP-Client: <ul><li>Zum Senden von Authentifizierungsanfragen an das Backend (RestAPI).</li></ul></li><li>Token-Management: <ul><li>Speicherung von JWTs (z. B. im localStorage oder Cookies).</li></ul></li><li>Routing: <ul><li>Weiterleitung zu geschützten Seiten nach erfolgreicher Anmeldung.</li><li>Zugangsbeschränkung zu sensiblen Bereichen der App.</li></ul></li></ol><br> **Technologien**: <ol><li>Framework: <ul><li>C#</li><li>HTML</li></ul></li><li>HTTP-Anfragen: <ul><li>RestAPI</li></ul></li><li>Sicherheitsmaßnahmen: <ul><li>HTTPS</li></ul></li><li>Styling: <ul><li>Eigenes CSS</li></ul></li><li>Token-Handling: <ul><li>JWT</li></ul></li><li>Datenbank: <ul><li>PostgreSQL</li></ul></li></ol> **Diese gelten für alle folgenden Punkte!** | ZUG-1 |

<table><tbody>
<tr><td style="text-align: left"><p><strong><b>Passwort zurücksetzen</b></strong>
</p><p>
<b>Im Frontend</b>
</p><p>

<b>Beschreibung:</b>
</p><p>
Die Passwort-Zurücksetzen-Funktion im Frontend ermöglicht es Benutzern, über eine Benutzeroberfläche einen Token-basierten Prozess zur Passwortänderung zu starten.
</p><p>

<b>Benötigte Komponenten:</b>
</p><p>
1. Eingabefeld für die E-Mail-Adresse.</p><p>
2. Formular zur Eingabe des neuen Passworts nach Token-Bestätigung.</p><p>
3. Fehler- und Erfolgsmeldungen zur Benutzerführung.
</p><p>

</p>
<p>Backend:</p>
<p>Passwortreset-Funktion: Benutzer können ihre E-Mail-Adresse eingeben, um einen Passwortreset anzufordern.
E-Mail-Versand: Die Anwendung sendet einen Link mit einem einmaligen, zeitlich begrenzten Token an die angegebene E-Mail-Adresse.
Sicherheitsanforderungen: Der Token muss sicher generiert werden, und der Link darf keine sensiblen Informationen enthalten.
Benutzeroberfläche: Die Oberfläche für den Passwortreset muss benutzerfreundlich sein und eine Bestätigung anzeigen.
Datenbankoperationen: Der neue Passwort-Hash wird in der Datenbank gespeichert und überschreibt den alten Eintrag.
Fehlerbehandlung: Geeignete Fehlermeldungen müssen angezeigt werden, wenn die E-Mail nicht registriert ist oder der Token abgelaufen ist.
Protokollierung: Alle Passwortreset-Anfragen müssen protokolliert werden.</p></td>

<td><p>ZUG-2</p></td></tr>



<tr><td style="text-align: left"><p><strong><b>Rollen</b></strong>
</p><p>
<b>Im Frontend</b>
</p><p>

<b>Beschreibung:</b>
</p><p>
Die Implementierung von Rollen im Frontend dient der Steuerung von Benutzerzugriffen und Funktionen basierend auf deren Berechtigungen. Rollen legen fest, welche Inhalte und Aktionen für bestimmte Benutzergruppen sichtbar oder ausführbar sind.  
</p><p>

<b>Benötigte Komponenten:</b>
</p><p>
1. Rollenbasierte Navigation </p><p>
2. Zugriffskontroll-Guard </p><p>
3. UI-Elemente basierend auf Benutzerrolle
</p><p>


<p>Backend:</p>
<p>Rollendefinition:
Definieren von Rollen (z.B. Administrator, Benutzer, Gast) mit spezifischen Berechtigungen.
Datenbankstruktur:
Entwurf einer Datenbanktabelle zur Speicherung von Rollen und deren Berechtigungen.
Rollenvergabe:
Implementierung von Funktionen zur Zuweisung und Entziehung von Rollen an Benutzer im Backend.
Berechtigungsprüfung:
Entwicklung einer Middleware oder Funktion, die bei jeder Anfrage überprüft, ob der Benutzer die erforderlichen Berechtigungen für die angeforderte Aktion hat.
Sicherheitsanforderungen:
Sicherstellen, dass nur autorisierte Benutzer (z.B. Administratoren) Rollen ändern oder zuweisen können.
Protokollierung:
Implementierung von Protokollierungsmechanismen für Änderungen an Rollen und Berechtigungen zur Nachverfolgbarkeit.</p></td>

<td><p>ZUG-3</p></td></tr>



<tr><td style="text-align: left"><p><strong><b>Benutzerverwaltung (für Admins)</b></strong>
</p><p>
<b>Im Frontend</b>
</p><p>

<b>Beschreibung:</b>
</p><p>
Die Benutzerverwaltung erlaubt Administratoren, Benutzerkonten zu verwalten, einschließlich Erstellung, Bearbeitung, Aktivierung/Deaktivierung und Löschung von Benutzern sowie Zuweisung von Rollen und Berechtigungen.
</p><p>

<b>Benötigte Komponenten:</b>
</p><p>
1. Liste der Benutzer mit Rollen und Status </p><p>
2. Buttons zum Bearbeiten und Löschen von Benutzern </p><p>
3. Such- und Filterfunktionen für Benutzer
</p><p>

<p>Backend:</p>
<p>Datenbankoperationen:
Alle Änderungen, die über die Weboberfläche im Admin-Bereich vorgenommen werden, müssen über definierte Backend-API-Endpunkte in der Datenbank gespeichert werden.
Zugriffssteuerung:
Implementierung einer strengen Zugriffssteuerung, die sicherstellt, dass nur autorisierte Benutzer (z.B. Administratoren) Änderungen vornehmen können.
Berechtigungsprüfung:
Vor jeder Datenbankoperation muss eine Überprüfung der Benutzerrollen und -berechtigungen erfolgen, um sicherzustellen, dass der Benutzer die erforderlichen Rechte hat.
Validierung der Eingaben:
Alle Eingaben, die über die Weboberfläche an das Backend gesendet werden, müssen validiert werden, um sicherzustellen, dass sie den erwarteten Formaten und Werten entsprechen.
Protokollierung von Änderungen:
Alle Änderungen, die im Admin-Bereich vorgenommen werden, müssen protokolliert werden, um eine Nachverfolgbarkeit und Auditierung zu ermöglichen.
Sicherheitsmaßnahmen:
Implementierung von Sicherheitsmaßnahmen wie Rate Limiting und IP-Whitelisting, um unbefugte Zugriffe zu verhindern.
Fehlerbehandlung:
Bereitstellung von klaren Fehlermeldungen und Handhabung von unerwarteten Situationen, um die Integrität der Daten zu gewährleisten.</p></td>
<td><p>ZUG-4</p></td></tr>



<tr><td style="text-align: left"><p><strong><b>Einladung an die EDU-Adresse (Phase 2)</b></strong>
</p><p>
<b>Im Frontend</b>
</p><p>

<b>Beschreibung:</b>
</p><p>
In Phase 2 wird die Möglichkeit geschaffen, Benutzern eine Einladung zur Registrierung oder Teilnahme über eine EDU-E-Mail-Adresse zu senden. Diese Einladung erfolgt in Form einer E-Mail, die den Benutzer zur Anmeldung auf der Plattform einlädt. 
</p><p>

<b>Benötigte Komponenten:</b>
</p><p>
1. Eingabefeld für die EDU-E-Mail-Adresse </p><p>
2. Button zum Versenden der Einladung </p><p>
3. Bestätigungs- und Fehlermeldungen für den Versand
</p><p>


<p>Backend:</p>
<p>Einladungserstellung:
Implementierung einer Funktion zur Erstellung einer Einladung, die alle erforderlichen Informationen (z.B. Empfänger, Betreff, Nachricht, Datum, Uhrzeit) erfasst.
Datenbankintegration:
Speichern der Einladung in der Datenbank, einschließlich aller relevanten Details und des Status (z.B. erstellt, versendet).
E-Mail-Vorlage:
Erstellung einer E-Mail-Vorlage, die die Einladung in einem ansprechenden Format darstellt.
E-Mail-Versand:
Implementierung einer Funktion, die die Einladung per E-Mail an den vorgesehenen Empfänger sendet, einschließlich der Verwendung eines E-Mail-Dienstes (z.B. SMTP-Server).
Berechtigungsprüfung:
Sicherstellen, dass nur autorisierte Benutzer (z.B. Administratoren) Einladungen erstellen und versenden können.
Fehlerbehandlung:
Implementierung von Mechanismen zur Fehlerbehandlung, um sicherzustellen, dass der Benutzer über den Erfolg oder das Scheitern des E-Mail-Versands informiert wird.
Protokollierung:
Protokollierung aller Einladungen, die erstellt und versendet wurden, um eine Nachverfolgbarkeit zu gewährleisten.
Eingabever validation:
Validierung der Eingaben (z.B. E-Mail-Adresse, Datum) vor der Erstellung und dem Versand der Einladung, um sicherzustellen, dass sie korrekt sind.</p></td>
<td><p>ZUG-5</p></td></tr>


<tr><td style="text-align: left"><p><strong><b>Magic Link Authentifizierung</b></strong>
</p><p>
<b>Im Frontend</b>
</p><p>

<b>Beschreibung:</b>
</p><p>
Die Magic Link Authentifizierung ermöglicht es Benutzern, sich ohne Passwort anzumelden, indem sie auf einen Link klicken, der ihnen per E-Mail zugeschickt wird. Dieser Link ist temporär und führt den Benutzer direkt zur Anwendung, wenn er gültig ist.  
</p><p>

<b>Benötigte Komponenten:</b>
</p><p>
1. Eingabefeld für die E-Mail-Adresse</p><p>
2. Button zum Anfordern des Magic Links</p><p>
3. Weiterleitung zur Bestätigungsseite nach Klick auf den Magic Link
</p><p>



<p>Backend:</p>
<p>Benutzerregistrierung::
Implementierung einer Funktion zur Registrierung potenzieller Benutzer, die ihre E-Mail-Adresse und andere erforderliche Informationen erfasst.
E-Mail-Versand:
Nach der Registrierung muss eine E-Mail an die angegebene Adresse gesendet werden, die einen Authentifizierungslink enthält.
Link-Generierung:
Der Authentifizierungslink muss einen einmaligen, kryptografisch sicheren Token enthalten, der mit dem Benutzerkonto verknüpft ist und eine begrenzte Gültigkeitsdauer hat (z.B. 24 Stunden).
Datenbankeintrag:
Der Token und der Status der Authentifizierung müssen in der Datenbank gespeichert werden, um die Gültigkeit des Links zu überprüfen.
Link-Verifizierung:
Implementierung einer Funktion, die den Token überprüft, wenn der Benutzer auf den Link klickt, um sicherzustellen, dass er gültig und nicht abgelaufen ist.
Benutzeraktivierung:
Nach erfolgreicher Verifizierung des Tokens muss das Benutzerkonto aktiviert werden, und der Benutzer sollte auf eine Bestätigungsseite weitergeleitet werden.
Fehlerbehandlung:
Bereitstellung von klaren Fehlermeldungen, wenn der Token ungültig oder abgelaufen ist, und gegebenenfalls die Möglichkeit zur erneuten Anforderung des Authentifizierungslinks.
Protokollierung:
Protokollierung aller Authentifizierungsanfragen und -versuche, um eine Nachverfolgbarkeit zu gewährleisten.</p></td>

<td><p>ZUG-6</p></td></tr>



<tr><td style="text-align: left"><p><strong><b>2FA Authentifizierung (Phase 2)</b></strong>
</p><p>
<b>Im Frontend</b>
</p><p>

<b>Beschreibung:</b>
</p><p>
In Phase 2 wird die Zwei-Faktor-Authentifizierung (2FA) implementiert, um die Sicherheit des Benutzerkontos zu erhöhen. Nach der Eingabe des Benutzernamens und Passworts wird ein zweiter Authentifizierungsfaktor benötigt, wie ein einmaliger Code, der an das Handy des Benutzers gesendet wird.
</p><p>

<b>Benötigte Komponenten:</b>
</p><p>
1. Eingabefeld für den OTP (One-Time-Password)</p><p>
2. Button zur Bestätigung des OTPs</p><p>
3. Fehler- und Erfolgsmeldungen für die OTP-Verifizierung
</p><p>

<p>Backend:</p>
<p>Anmeldedatenüberprüfung:
Nach der Eingabe der Anmeldedaten (Benutzername und Passwort) muss das System die Anmeldedaten validieren und überprüfen.
Code-Generierung:
Implementierung einer Funktion zur Generierung eines zeitlich begrenzten Codes (z.B. TOTP - Time-based One-Time Password), der auf einem anderen Gerät (z.B. Smartphone) generiert wird.
Code-Übermittlung:
Der generierte Code muss über eine sichere Kommunikationsoberfläche (z.B. Push-Benachrichtigung, SMS oder E-Mail) an den Benutzer gesendet werden.
Benutzereingabe:
Der Benutzer muss die Möglichkeit haben, den erhaltenen Code in die Anmeldemaske einzugeben, um seine Identität zu bestätigen.
Code-Überprüfung:
Implementierung einer Funktion zur Überprüfung des eingegebenen Codes gegen den generierten Code, um sicherzustellen, dass er korrekt und innerhalb der Gültigkeitsdauer ist.
Fehlerbehandlung:
Bereitstellung von klaren Fehlermeldungen, wenn der eingegebene Code ungültig oder abgelaufen ist, sowie die Möglichkeit, einen neuen Code anzufordern.
Sicherheitsanforderungen:
Sicherstellen, dass die Kommunikation zwischen dem Server und dem Gerät des Benutzers sicher ist (z.B. durch Verschlüsselung).
Protokollierung:
Protokollierung aller Anmeldeversuche und der Verwendung von Codes zur Nachverfolgbarkeit und zur Erkennung von potenziellen Sicherheitsvorfällen.</p></td>

<td><p>ZUG-7</p></td></tr>



<tr><td style="text-align: left"><p><strong><b>OAuth (Phase 2)</b></strong>
</p><p>
<b>Im Frontend</b>
</p><p>

<b>Beschreibung:</b>
</p><p>
In Phase 2 wird die OAuth-Authentifizierung implementiert, die es Benutzern ermöglicht, sich über Drittanbieter wie Google, Facebook oder andere Plattformen anzumelden. Dabei wird der Benutzer direkt zu einer externen OAuth-Plattform weitergeleitet, um sich zu authentifizieren, und anschließend wieder zurück zur Anwendung.  
</p><p>

<b>Benötigte Komponenten:</b>
</p><p>
1. Button für die Auswahl des OAuth-Anbieters (z. B. Google, Facebook)</p><p>
2. Weiterleitung zur OAuth-Anmeldeseite des Anbieters</p><p>
3. Empfang und Verarbeitung des Tokens nach erfolgreicher Anmeldung
</p><p>


<p>Backend:</p>
<p>OAuth 2.0 Integration:
Implementierung des OAuth 2.0-Protokolls zur Authentifizierung über LinkedIn. Dies umfasst die Registrierung der Anwendung bei LinkedIn und den Erhalt der erforderlichen Client-ID und Client-Secret.
Benutzeranmeldung:
Bereitstellung eines Endpunkts, über den Benutzer sich mit ihrem LinkedIn-Account anmelden können. Dies sollte einen Redirect zur LinkedIn-Login-Seite und die anschließende Rückleitung zur eigenen Anwendung nach erfolgreicher Authentifizierung umfassen.
Token-Verwaltung:
Nach erfolgreicher Authentifizierung muss das Backend den von LinkedIn erhaltenen Access-Token speichern, um zukünftige Anfragen an die LinkedIn-API zu ermöglichen.
Mapping von LinkedIn-Accounts:
Implementierung einer Datenbanktabelle, die das Mapping zwischen LinkedIn-Accounts (z.B. LinkedIn-ID) und den internen Benutzerkonten in der eigenen Anwendung speichert.
Profilabgleich (Zukünftige Ausbaustufe):
In einer späteren Phase sollte eine Funktion implementiert werden, die es ermöglicht, das LinkedIn-Profil des Benutzers abzurufen und mit dem eigenen Benutzerprofil abzugleichen. Dies könnte Informationen wie Name, E-Mail-Adresse, Berufserfahrung und Fähigkeiten umfassen.
Sicherheitsanforderungen:
Sicherstellen, dass alle Daten, die von LinkedIn abgerufen werden, sicher gespeichert und verarbeitet werden, um die Privatsphäre der Benutzer zu schützen.
Fehlerbehandlung:
Implementierung von Mechanismen zur Fehlerbehandlung, um mit möglichen Problemen bei der Authentifizierung oder beim Abrufen von Daten von LinkedIn umzugehen.
Protokollierung:
Protokollierung aller Authentifizierungsversuche und der zugehörigen LinkedIn-Daten, um eine Nachverfolgbarkeit und Analyse von Anmeldeaktivitäten zu ermöglichen.</p></td>
<td><p>ZUG-8</p></td></tr></tbody></table>

## Hall of Fame (Phase 2)

| PDF-Generierung<br><br>Frontend:  <br>Das System muss eine PDF-Generierung im Frontend der Hall of Fame für Treffen ermöglichen. Nutzer sollen ihre persönlichen Erfolge in einem ansprechenden Dokument festhalten können. Jedes PDF soll ein Bild der Person sowie eine Übersicht über ihre Schullaufbahn, berufliche Stationen und besondere Leistungen enthalten. Diese Dokumente sollen anschließend ausgedruckt und zur Präsentation verwendet werden können. | HoF-1 |
| --- | --- |
| Online Hall of Fame<br><br>Frontend:  <br>Das System muss eine Online Hall of Fame im Frontend bereitstellen, die es Nutzern ermöglicht, ihre Erfolge und besonderen Leistungen zu präsentieren. Diese Plattform soll eine ansprechende und motivierende Darstellung von Nutzerbeiträgen bieten, sodass herausragende Leistungen sichtbar gemacht und gewürdigt werden können. | HoF-2 |
| OptIn Modell für Benutzer<br><br>Frontend:  <br>Das System muss ein Opt-In-Modell im Frontend der Hall of Fame für Treffen bereitstellen, das es Nutzern ermöglicht, aktiv zu entscheiden, ob sie in die Ruhmeshalle aufgenommen werden möchten. Durch eine einfache Zustimmung können Nutzer ihre Erfolge und Beiträge sichtbar machen, während sie gleichzeitig die Kontrolle über ihre Daten behalten und sicherstellen, dass nur die gewünschten Informationen geteilt werden. | HoF-3 |
| Löschantrag<br><br>Frontend:  <br>Das System muss ein Opt-In-Modell im Frontend der Hall of Fame für Treffen bereitstellen, das es Nutzern ermöglicht, aktiv zu entscheiden, ob sie in die Ruhmeshalle aufgenommen werden möchten. Durch eine einfache Zustimmung können Nutzer ihre Erfolge und Beiträge sichtbar machen, während sie gleichzeitig die Kontrolle über ihre Daten behalten und sicherstellen, dass nur die gewünschten Informationen geteilt werden. | HoF-4 |

## Firmen und Jobstellenmarkt (Phase 2)

| Agenturschnittstellen (API & GUI) | JOB-1 |
| --- | --- |
| Job / Mitarbeiterbörse / Praktikabörse | JOB-2 |
| Privatsphäre Einstellungen | JOB-3 |

## Premiumbereich (Phase 2)

| Anforderung | ID |
| --- | --- |
| <b>Verwaltung der Premiumkunden</b> </p><p> 1. Benutzerverwaltung:<br>  - Identifikation und Segmentierung der Premiumkunden.<br> -Erstellung und Verwaltung individueller Kundenprofile.<b> <p/><p> 2. Serviceverwaltung: <br> -Bereitstellung maßgeschneiderter Dienstleistungen und Angebote. <br> -Exklusive Inhalte oder Angebote für Premiumkunden.<br> </p><p> 3. Kommunikationssystem:<b> -Regelmäßige und personalisierte Kommunikation über E-Mail, Push-Benachrichtigungen oder Messaging-Dienste.<b> 4. Feedback- und Zufriedenheitstools:<b> -Sammlung von Kundenfeedback <br> -Tools zur Überwachung und Analyse der Kundenzufriedenheit.</p><p> Technologien: <br> -Datenbank:  MySQL, PostgreSQL oder MongoDB zur Speicherung von Kundeninformationen und Präferenzen.<br>  -CRM-System: Salesforce, HubSpot oder eine Eigenentwicklung zur Kundenverwaltung.<br>  -Kommunikation: SMTP (z. B. SendGrid) für E-Mails,Websockets für Echtzeitkommunikation.<br> -Datenanalyse: Tools wie Power BI oder Google Analytics zur Zufriedenheitsüberwachung.</p><p> | PRE-1 |
| <b>Ingenieurantrag <b> </p><p> -Ein Ingenieurantrag umfasst die Vorbereitung der Unterlagen, das Ausfüllen des Antragsformulars, die Einreichung bei der Behörde, die Prüfung und Genehmigung des Antrags sowie die Dokumentation für zukünftige Referenzen.</p><p> Technologien und Komponenten:<br> -Dokumentenmanagementsystem (DMS): Für die Verwaltung und Archivierung der erforderlichen Unterlagen.<br> -Online-Formularsystem: Zur Eingabe und Übermittlung der Antragdaten.<br> -Behördenportale: Nutzung digitaler Plattformen für die Einreichung.<br> -Projektmanagement-Tool: Zur Nachverfolgung der Bearbeitungsschritte und Fristen.<br> -Kommunikationsplattformen: Für Rückfragen mit Behörden. | PRE-2 |
| <b>Matura & Klassentreffen organisieren</b></p><p> -Die Organisation eines Matura- und Klassentreffens umfasst die Festlegung von Datum und Ort, die Erstellung einer Gästeliste, das Versenden von Einladungen, die Planung des Programms und die Koordination von Verpflegung und Dekoration.</p><p> <b>Technologien und Komponenten:</b><br> -Doodle oder ähnliche Umfragetools: Zur Abstimmung von Datum und Ort.<br>-Excel/Google Sheets: Für die Erstellung und Verwaltung der Gästeliste.<br> -E-Mail-Marketing-Tools: Zum Versenden von Einladungen.<br> -Eventmanagement-Plattformen: Für Programmentwurf und Aufgabenverteilung.<br> -Cloud-basierte Kalender und Tools: Für die Koordination von Verpflegung und Dekoration. | PRE-3 |

## Auswertungen

Mehr Prosa (Unterscheidung Phase 1 & 2)

| Anforderung | ID |
| --- | --- |
| **Dashboard**<br><br>Frontend: <br>Anforderung:<br> Das Frontend der Webanwendung stellt ein Dashboard bereit, das sicherheitsrelevante Informationen übersichtlich darstellt. Es ermöglicht dem Benutzer, Anmeldeaktivitäten einzusehen, Sicherheitsfunktionen zu verwalten und Benachrichtigungen zu neuen Login-Versuchen zu erhalten. Die Benutzerfreundlichkeit, Transparenz und Barrierefreiheit stehen hierbei im Fokus. <br> Funktionale Anforderungen <br> Das Dashboard zeigt eine Liste der letzten Anmeldeaktivitäten mit folgenden Details: <br>Datum und Uhrzeit <br>Verwendetes Gerät/Browser<br>Das Dashboard bietet direkte Zugriffsmöglichkeiten auf sicherheitsrelevante Funktionen:<br> Änderung des Passworts<br>Aktivierung/Deaktivierung der Zwei-Faktor-Authentifizierung (2FA) (Phase 2)<br>Verwaltung aktiver Sitzungen mit der Möglichkeit, einzelne Sitzungen zu beenden<br>Anzeige und Verwaltung vertrauenswürdiger Geräte <br>Die Darstellung erfolgt in einer übersichtlichen und leicht verständlichen Struktur:<br>Sicherheitsoptionen sind intuitiv erreichbar und mit kurzen Erklärungen versehen.<br>Das Design ist responsive und für Desktop, Tablet und mobile Endgeräte optimiert. <br>Das Dashboard erfüllt Barrierefreiheitsstandards und unterstützt Screenreader sowie Tastatur-Navigation:<br>Visuelle Warnhinweise zu sicherheitsrelevanten Ereignissen werden durch alternative Texte und Symbole ergänzt. <br>Akzeptanzkriterien<br>Die letzten Anmeldeaktivitäten werden vollständig und korrekt angezeigt.<br>Sicherheitsfunktionen wie Passwortänderung, 2FA-Verwaltung (Phase 2) sind direkt zugänglich und funktional.<br>Das Dashboard ist auf verschiedenen Geräten benutzerfreundlich und barrierefrei bedienbar.<br><br>Backend:<br><br>Datenintegration: Abruf und Aggregation von Systemdaten wie Nutzeraktivität, Serverstatus und Verkaufszahlen in Echtzeit. Datenvisualisierung: Darstellung der KPIs in klaren und verständlichen Diagrammen und Tabellen zur schnellen Analyse und Entscheidungsfindung. Benutzeroberfläche: Entwicklung einer übersichtlichen und interaktiven Dashboard-Oberfläche, die eine einfache Navigation und detaillierte Auswertungen ermöglicht. Zugriffsrechte: Implementierung von Berechtigungen, um sicherzustellen, dass nur autorisierte Benutzer auf spezifische Dashboard-Daten zugreifen können. Leistung und Skalierbarkeit: Verwendung von performanten Datenbanken und effizienten Algorithmen zur schnellen Verarbeitung und Darstellung großer Datenmengen. Echtzeit-Daten: Sicherstellung der kontinuierlichen Aktualisierung und Anzeige von Echtzeit-Daten für aktuelle Systemauswertungen. Sicherheit: Gewährleistung der Sicherheit durch Verschlüsselung der Datenübertragung und Schutz vor unbefugtem Zugriff. | AUS-1 |
| Auswertungen erstellen<br><br>Frontend:  <br>Das System muss präzise Analysen der Anmeldedaten ermöglichen. Dazu gehören die Erfassung und Auswertung der Login-Häufigkeit, die Identifikation verdächtiger Aktivitäten sowie die Bereitstellung von Einblicken in das Nutzerverhalten. Die Ergebnisse sollen in einer übersichtlichen und interaktiven Darstellung visualisiert werden, um eine optimierte Sicherheitsstrategie zu unterstützen.<br><br>Backend:<br><br>Datenstrukturierung: Erfassung und Strukturierung der Rohdaten, um die Grundlage für präzise Auswertungen zu bilden. Filter und Algorithmen: Entwicklung und Implementierung von Filtern und Algorithmen zur Berechnung der relevanten KPIs. Datenvisualisierung: Darstellung der Auswertungsergebnisse in klaren Diagrammen und Tabellen zur einfachen Analyse. Zugriffsrechte: Sicherstellung, dass nur berechtigte Benutzer auf die Auswertungsdaten zugreifen können. Datenbankleistung: Nutzung einer performanten Datenbank, die schnelle Datenabfragen und Analysen ermöglicht. Echtzeit-Verarbeitung: Implementierung von Mechanismen zur schnellen Verarbeitung und Analyse von Daten in Echtzeit. Sicherheit: Sicherstellung der Datensicherheit durch Verschlüsselung und Schutz vor unbefugtem Zugriff. | AUS-2 |
| Auswertugnen erstellen 2 (Phase 2)<br><br>Frontend:  <br>Das System muss detaillierte Analysen zu Login-Standorten und verwendeten Geräten bereitstellen. Es soll ermöglichen, Zeiträume mit der höchsten Anmeldeaktivität zu identifizieren und potenzielle Sicherheitslücken durch den Vergleich von Nutzeraktivitäten aufzudecken. Zusätzlich müssen detaillierte Statistiken zu fehlgeschlagenen Login-Versuchen sowie häufig genutzten Wiederherstellungsfunktionen erfasst und visualisiert werden, um gezielte Sicherheitsmaßnahmen abzuleiten.<br><br>Backend:<br><br> Datenquellen: Sicherstellung zuverlässiger und aktueller Datenquellen zur Grundlage der Auswertungen. Filter und Algorithmen: Entwicklung und Anwendung von Filtern sowie Algorithmen zur Berechnung relevanter Metriken und KPIs. Datenbank: Nutzung einer performanten und skalierbaren Datenbank für schnelle Datenverarbeitung und -abfragen. Visualisierung: Integration von Visualisierungstools, die die berechneten Metriken in übersichtliche Diagramme und Tabellen umwandeln. Zugriffsrechte: Implementierung von Zugriffssteuerungen, die den Datenzugriff nur für autorisierte Benutzer ermöglichen. Analysebasis: Gewährleistung einer präzisen, schnellen und sicheren Analyse durch effiziente Datenverarbeitung und -visualisierung. Sicherheit: Sicherstellung der Datenintegrität und des Schutzes vor unbefugtem Zugriff oder Manipulation. | AUS-3 |
| Chart generierung (Phase 2)<br><br>Frontend:  <br>Das System muss eine visuelle Aufbereitung der Anmeldedaten in Form von Charts ermöglichen. Dies umfasst die Darstellung von Login-Zeiten, regionalen Verteilungen sowie der Anzahl erfolgreicher und fehlgeschlagener Anmeldeversuche. Die Visualisierungen sollen eine schnelle Analyse der Nutzeraktivitäten ermöglichen und Trends auf einen Blick erkennbar machen.<br><br>Backend:<br><br> Datenquelle und Filter: Kontinuierliches Laden und Filtern von Rohdaten aus zuverlässigen Quellen zur Vorbereitung der Chart-Generierung. Datenaggregation: Entwicklung von Algorithmen, die die gefilterten Rohdaten aggregieren und für die Visualisierung aufbereiten.Charting-Bibliothek: Integration einer Charting-Bibliothek zur Erstellung von Diagrammen (Balken-, Linien- oder Kreisdiagramme) aus den aggregierten Daten. <br> Caching: Implementierung von Caching-Mechanismen, um die Geschwindigkeit der Datenverarbeitung und Chart-Darstellung zu optimieren. <br> Zugriffsrechte: Sicherstellung, dass nur autorisierte Benutzer auf die generierten Charts zugreifen können. Datenvisualisierung: Bereitstellung von klaren, leicht verständlichen Diagrammen zur Unterstützung schneller Entscheidungen. Sicherheit: Schutz der Daten durch Verschlüsselung und Zugriffskontrollen, um die Integrität und Vertraulichkeit zu gewährleisten. | AUS-4 |

## Datenschutz & Informationssicherheit

| Anforderung | ID |
| --- | --- |
| **DSGVO-Konform**<br><br>Dass man die Anforderungen der Datenschutz-Grundverordnung (DSGVO) der Europäischen Union erfüllt. Die DSGVO ist eine Verordnung, die darauf abzielt, den Schutz personenbezogener Daten zu stärken und die Kontrolle über die Verwendung und Verarbeitung solcher Daten zurück in die Hände der betroffenen Personen zu legen. | DSc-1 |
| **Informationssicherheit**<br><br>Bezeichnet den Schutz von Informationen vor verschiedenen Bedrohungen, um deren Vertraulichkeit, Integrität und Verfügbarkeit zu gewährleisten. Ziel ist es, dass Daten vor unbefugtem Zugriff, Verlust, Missbrauch oder Zerstörung geschützt sind. Alle Daten müssen im Backend geschützt werden. (Serverseitige validierung jedes Requests...) | DSc-2 |

## Schwarzes Brett (Phase 2)

| Anforderung | ID |
| --- | --- |
| **Feed**<br>Es muss ein Interface / eine Schnittstelle für alle Elemente, welche am Schwarzen Brett auftauchen geschaffen werden. Dann muss eine API Route für das Abrufen der einzelnen Einträge geschaffen werden. Die gesammte Entwicklung wird in einem Oqtane Modul geschehen. Der Feed priorisiert die Posts vom Absolventenverein und muss die Sichtbarkeitsstufe des Posts berücksichtigen.<br>Eine Seite auf den Mitteilungen und Ankündigungen gemacht werden. Hier kann man Events anzeigen lassen, Posts anderer Mitglieder usw. | ScB-1 |
| **Posten**<br>Es wird eine neue API Route in dem Modul implementiert, die es ermöglicht eigene Einträge auf dem schwarzen Brett zu posten. Hierfür braucht man nichts wirklich ausgefallenes.<br>Jeder darf posten, solange ihm in der Vergangenheit dieses Privileg nicht weggenommen wurde. Diese Posts werden dann in dem Feed angezeigt. Ein Post kann eine Sichbarkeitsstufe haben (standardmäßig: öffentlich = jeder angemeldete Benutzer) | ScB-2 |
| **Werbung**<br>Um Werbung auf dem schwarzen Brett anbieten zu können, muss mitgezählt werden, welche Posts geladen / gesehen worden sind. Es wird auch eine "Abrechnungsseite" geben, auf der die Kosten Vorgerechnet werden. Um die Abrechnung muss sich der Absolventen Verein selber kümmern.<br>Firmen können Job Inserate schalten, Diplomarbeitskooperationen anbieten usw. Wir stellen die Schnittstelle für diese Firmen bereit, aber um die Abrechnung muss sich gesondert jemand anderer kümmern | ScB-3 |
| **Meldungsvorgang**<br>Es werden neue Knöpfe bei den Posts hinzugefügt, mit denen man einen Post melden kann. Optional mit Angabe eines Grundes. Dieser Post wird sofort offline genommen und dann zur Durchsicht von Seiten des Absolventenvereins markiert. Je nach dem, was der AV dann Beschließt, wird dem Benutzer dann das Recht auf Posten entzogen.<br>Man kann unangemessene Inhalte melden, diese Meldungen werden dann von Hand durchgeschaut, ob diese den Regeln widersprechen, und kann dem Benutzer über eine Rollenänderung das Privileg des Postens / Interagieren mit anderen Nutzern auf der Seite entfernt werden. | ScB-4 |

## Anmeldetool für Treffen

| Anforderung | ID |
| --- | --- |
| Event erstellen<br><br>Frontend:  <br>Das Frontend ermöglicht Absolventen die Erstellung und Verwaltung von Treffen durch ein Eingabeformular für Event-Details, eine Teilnehmerverwaltung mit Einladungsfunktion sowie eine übersichtliche Event-Liste mit Bearbeitungsoptionen. Benachrichtigungen über Änderungen und ein responsives Design sorgen für eine nutzerfreundliche Bedienung. <br><br>Backend:<br><br> Eingabemaske: Entwicklung einer benutzerfreundlichen Maske zur Erstellung und Bearbeitung von Eventdaten, einschließlich relevanter Felder wie Titel, Datum, Zeit und Beschreibung. Datenbank: Einrichtung einer Datenbank zur sicheren Speicherung aller Eventdaten und ihrer zugehörigen Informationen. Verwaltung von Anmeldungen: Implementierung von Algorithmen zur Erfassung, Verwaltung und Nachverfolgung von Teilnehmeranmeldungen. Zugriffsrechte: Sicherstellung, dass nur autorisierte Benutzer Events erstellen oder bearbeiten können. Automatische Bestätigungen: Einrichtung eines Systems zur automatischen Versendung von Bestätigungen an Teilnehmer nach erfolgreicher Anmeldung.Benutzerfreundlichkeit: Gestaltung der Oberfläche und Funktionen so, dass Benutzer Events effizient und fehlerfrei erstellen und verwalten können. | AfT-1 |
| Einladungen verschicken<br><br>Frontend:  <br>Das System ermöglicht die Erstellung und Verwaltung von Events. Administratoren können Events anlegen, Teilnehmer sich anmelden und Benachrichtigungen erhalten. Alle Events und Anmeldungen werden protokolliert.<br><br>Backend:<br><br>Datenabruf: Entwicklung einer Funktion zum Abrufen der relevanten Eventdaten aus der Datenbank. Personalisierung: Erstellung von personalisierten Einladungstexten basierend auf Event- und Teilnehmerdaten. Nachrichtentransport: Integration einer API für den Versand der Einladungen per E-Mail und SMS. Zugriffsrechte: Sicherstellung, dass nur autorisierte Benutzer den Versand von Einladungen initiieren können. Automatisierung: Implementierung eines Systems zur automatischen Verarbeitung und Versendung der Einladungen nach definierten Kriterien. Protokollierung: Speicherung von Versandstatus und Fehlerprotokollen, um die Nachvollziehbarkeit und Fehlersuche zu gewährleisten. Sicherheit: Gewährleistung einer verschlüsselten Übertragung der Daten und Schutz vor unbefugtem Zugriff. | AfT-2 |
| Einladung beantworten (zu/absagen)<br><br>Frontend:  <br>Das System muss Nutzern ermöglichen, Einladungen direkt anzunehmen oder abzulehnen. Offene Einladungen sollen zentral verwaltet und der Status jederzeit einsehbar sein. Dies gewährleistet eine sichere und unkomplizierte Verwaltung der Zugangsberechtigungen.<br><br>Backend:<br><br>Datenbankintegration: Speicherung der Teilnahmeantworten (Zusage/Absage) in der Datenbank, verknüpft mit dem jeweiligen Event und Teilnehmer. Rückmeldungsverarbeitung: Entwicklung eines Algorithmus, der eingehende Antworten verarbeitet und den Eventstatus entsprechend aktualisiert (z. B. verfügbare Plätze).Benachrichtigungssystem: Automatische Benachrichtigung des Organisators über eingehende Zu- oder Absagen. <br> Zugriffsrechte: Sicherstellung, dass nur eingeladene und berechtigte Teilnehmer ihre Rückmeldung abgeben können. <br> Benutzerfreundlichkeit: Bereitstellung einer klaren und einfachen Schnittstelle, die Teilnehmern die Abgabe ihrer Rückmeldung ermöglicht. Sicherheit: Verschlüsselte Übertragung der Teilnahmeantworten und Schutz vor unbefugtem Zugriff oder Manipulation. Protokollierung: Erfassung und Speicherung der Antworten, inklusive Zeitstempel, zur Nachverfolgbarkeit und Fehleranalyse. | AfT-3 |
| Kategorisierung (Phase 2)<br><br>Frontend:  <br>Das System muss eine Kategorisierung der Anmeldetools für Treffen ermöglichen, um eine intuitive und effiziente Nutzung zu gewährleisten. Nutzer sollen zwischen den Optionen „Neue Veranstaltung erstellen“, „An Treffen teilnehmen“ und „Veranstaltungen verwalten“ wählen können. Zudem soll eine übersichtliche Filterung von Veranstaltungen möglich sein, sodass schnell erkennbar ist, wer das Event erstellt hat.<br><br>Backend:<br><br>Datenbankstruktur: Einrichtung einer Datenbanktabelle zur Definition und Verwaltung von Kategorien sowie zur Verknüpfung dieser Kategorien mit den Events. Automatische Zuordnung: Entwicklung eines Algorithmus, der Events basierend auf vordefinierten Kriterien automatisch der passenden Kategorie zuordnet. Benutzeroberfläche: Bereitstellung einer intuitiven Oberfläche für das Hinzufügen, Bearbeiten und Löschen von Kategorien.Zugriffsrechte: Implementierung eines Berechtigungssystems, das sicherstellt, dass nur autorisierte Benutzer Kategorien verwalten können. Flexibilität: Unterstützung dynamischer Änderungen an Kategorien und deren Kriterien ohne Beeinträchtigung bestehender Zuordnungen. Sicherheit: Verschlüsselte Übertragung und Speicherung der Kategoriedaten sowie Schutz vor unbefugtem Zugriff. Protokollierung: Dokumentation aller Änderungen an den Kategorien zur Nachvollziehbarkeit und Fehleranalyse.  | AfT-4 |
| Zielgruppenfilter (Phase 2)<br><br>Frontend:  <br>Das System muss einen Zielgruppenfilter für Anmeldetools bereitstellen, der es Nutzern ermöglicht, gezielt Veranstaltungen zu finden, die ihren Interessen entsprechen. Durch intuitive Auswahlmöglichkeiten soll der Zugang zu relevanten Treffen erleichtert werden, sodass passende Optionen schnell entdeckt werden können.<br><br>Backend:<br><br>Datenbankintegration: Erfassung und Speicherung der Teilnehmerdaten in der Datenbank, einschließlich Interessen, Demografie und Eventpräferenzen. Datenanalyse und Filter: Entwicklung eines Algorithmus, der Teilnehmerdaten basierend auf vordefinierten Kriterien (z. B. Interessen, Alter, Eventpräferenzen) analysiert und filtert. Benutzeroberfläche: Bereitstellung einer benutzerfreundlichen Oberfläche, die es ermöglicht, Zielgruppenfilter zu erstellen, anzupassen und anzuwenden. Zugriffsrechte: Sicherstellung, dass nur autorisierte Benutzer die Filter erstellen, anpassen oder anwenden können. Flexibilität: Unterstützung der Anpassung der Filterkriterien, um dynamische Zielgruppenselektionen basierend auf unterschiedlichen Anforderungen zu ermöglichen. Sicherheit: Verschlüsselte Speicherung und Übertragung der Teilnehmerdaten sowie Schutz vor unbefugtem Zugriff. Protokollierung: Dokumentation der Anwendung von Zielgruppenfiltern zur Nachverfolgbarkeit und Analyse von Änderungen. | AfT-5 |

## Profilverwaltung

| Anforderung | ID |
| --- | --- |
| Profil erstellen <br><br>Frontend:  <br>Das System muss eine Profilverwaltung im Frontend bieten, die es Nutzern ermöglicht, ein individuelles Profil zu erstellen. Nutzer sollen ihre Interessen, Präferenzen sowie persönliche Informationen einfach eingeben können. Zudem sollen sie vergangene Veranstaltungen hinzufügen können, um passende Treffen basierend auf ihren Präferenzen schnell zu finden.<br><br>Backend:<br><br> Bereitstellung von Eingabefeldern für persönliche Daten (z. B. Name, E-Mail, Geburtsdatum). Validierung der Eingaben auf Vollständigkeit und Korrektheit (Pflichtfelder, Formatprüfung). Zugriff nur für autorisierte Nutzer mit entsprechender Berechtigung.API-Schnittstelle zum Erstellen und Bearbeiten von Profilen mit Validierung und Fehlerhandling. | Pro-1 |
| Profil bearbeiten<br><br>Frontend:  <br>Das System muss eine einfache und benutzerfreundliche Profilbearbeitung im Frontend ermöglichen. Nutzer sollen ihre Informationen schnell und unkompliziert aktualisieren können, einschließlich Interessen, persönlicher Daten und vergangener Veranstaltungen. Die Eingabefelder müssen intuitiv gestaltet sein, sodass Nutzer ihr Profil stets aktuell und relevant halten können.<br><br>Backend:<br><br>Editierfunktionen: Benutzer können ihre Profilinformationen über ein Formular bearbeiten. Validierung: Eingaben werden geprüft; nur gültige Daten werden gespeichert.Datenbank: Änderungen werden direkt und sicher in der Datenbank gespeichert. Zugriffsrechte: Nur autorisierte Benutzer dürfen ihre eigenen Profile bearbeiten. Benutzeroberfläche: Intuitive und leicht bedienbare Oberfläche zur Profilbearbeitung. Sicherheit: Verschlüsselte Datenübertragung und Schutz vor Sicherheitsrisiken. | Pro-2 |
| Profil mit LinkedIn automatisch abgleichen lassen<br><br>Frontend:  <br>Das System muss eine Funktion zum automatischen Abgleich des Profils mit LinkedIn bieten. Durch einen einfachen Klick sollen relevante Daten, wie berufliche Erfahrungen und Interessen, nahtlos übernommen werden. Diese Funktion erleichtert die Erstellung und Aktualisierung des Profils, sodass es stets aktuell und ansprechend bleibt.<br><br>Backend:<br><br> API-Integration: Die LinkedIn-API wird eingebunden, um Profilinformationen der Benutzer abzurufen. Datenabgleich: Ein Algorithmus überprüft und synchronisiert die abgerufenen LinkedIn-Daten mit den bestehenden Profildaten. Änderungen werden automatisiert in der Datenbank gespeichert. Zugriffsrechte: Nur autorisierte Benutzer dürfen den Abgleich starten. Zugriffsversuche ohne Berechtigung werden verhindert. Benutzeroberfläche: Eine intuitive Oberfläche ermöglicht es den Nutzern, den Abgleich mit LinkedIn einfach auszuführen. Sicherheit: Die Kommunikation mit der LinkedIn-API erfolgt verschlüsselt, und die Daten werden gemäß Sicherheitsstandards verarbeitet und gespeichert. Protokollierung: Alle Abgleichvorgänge werden protokolliert, um Nachvollziehbarkeit und Fehleranalyse zu gewährleisten. | Pro-3 |
| Profil verwaltung<br><br>Frontend:  <br>Das System muss eine benutzerfreundliche Profilverwaltung im Frontend bieten, die es Nutzern ermöglicht, ihre Informationen mühelos zu verwalten. Nutzer sollen persönliche Daten, Interessen und vergangene Veranstaltungen anpassen können, um ein ansprechendes und relevantes Profil zu erstellen. Dieses Profil soll die Teilnahme an zukünftigen Treffen optimieren und eine gezielte Auswahl von relevanten Veranstaltungen erleichtern.<br><br>Backend:<br><br>Datenbank: Einrichtung einer Datenbank zur Speicherung und Verwaltung aller Profildaten. APIs: Implementierung von APIs zur Abfrage, Aktualisierung und Verwaltung der Profildaten. Validierung: Entwicklung von Algorithmen zur Prüfung und Sicherstellung gültiger Eingaben bei Änderungen oder Neuanlagen von Profilen. Benutzeroberfläche: Bereitstellung einer intuitiven Oberfläche für das Anzeigen und Bearbeiten von Profilen. Zugriffsrechte: Implementierung eines Berechtigungssystems, das sicherstellt, dass nur autorisierte Benutzer auf ihre eigenen Profildaten zugreifen und Änderungen vornehmen können. Sicherheit: Verschlüsselte Übertragung und Speicherung aller Profildaten sowie Schutz vor unbefugtem Zugriff und Manipulation. | Pro-4 |

# Datenbank

| Anforderung | ID |
| --- | --- |
| Datenbank<br><br>1. Zielsetzung <br> Entwicklung einer relationalen Datenbank mit PostgreSQL zur Speicherung und Verwaltung von Anwendungsdaten.<br><br>2. Datenbankdesign<br><br>Datenmodellierung: Erstellung eines konzeptionellen Modells (z.B. ER-Diagramm) zur Definition der Entitäten, Attribute und Beziehungen. Tabellenstruktur: Definition der Tabellen, einschließlich: Primärschlüssel Fremdschlüssel Datentypen für jedes Attribute<br><br>3. Implementierung der Datenbank<br><br>Erstellung der Datenbank: Anlegen der PostgreSQL-Datenbank und der erforderlichen Tabellen. Indizes: Implementierung von Indizes zur Optimierung der Abfragegeschwindigkeit.Constraints: Festlegung von Constraints (z.B. NOT NULL, UNIQUE) zur Gewährleistung der Datenintegrität.<br><br>4. Datenbankanbindung<br><br>Zugriffsmethoden: Definition der Methoden zur Anbindung der Anwendung an die PostgreSQL-Datenbank (z.B. über JDBC, Entity Framework). CRUD-Operationen: Implementierung der grundlegenden CRUD-Operationen (Create, Read, Update, Delete) für die Datenmanipulation.<br><br>5. Sicherheit<br><br>Benutzerverwaltung: Einrichtung von Benutzerrollen und Berechtigungen zur Kontrolle des Zugriffs auf die Datenbank.Datenverschlüsselung: Implementierung von Maßnahmen zur Sicherstellung der Datensicherheit (z.B. SSL-Verbindungen). | DB-1 |

# Dokumentation

## Projektdokumentation

| Pflichtenheft | DOK-1 |
| --- | --- |
| Systembeschreibung | DOK-2 |
| Disasterrecovery Handbuch | DOK-3 |
| Benutzer Handbuch | DOK-4 |
| Admin Handbuch | DOK-5 |
| Git Handbuch | Dok-6 |